<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="form-group col-md-3" :class="{'has-error': errors_grids.name}">
                <label>Nome da grade<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model="formData.name">
                <label class="error" v-if="errors_grids.name">{{errors_grids.name[0]}}</label>
            </div>

            <div v-for="(variation, index) in formData.variations">
                <div class="form-group col-md-3" :class="{'has-error': errors_variations.errors.name &&
                                                                        index == errors_variations.key}">
                    <label>Variação {{index + 1}}<b class="text-danger">*</b></label>
                    <div class="input-group">
                        <input type="text" class="form-control" v-model="formData.variations[index].name">
                        <div class="input-group-btn">
                            <button class="btn btn-danger" @click.prevent="removeVariation(index)">
                                <i class="fa fa-trash"></i>
                            </button>
                        </div>
                    </div>
                    <label class="error" v-if="errors_variations.errors.name && index == errors_variations.key">
                        {{errors_variations.errors.name[0]}}
                    </label>
                </div>
            </div>

            <div class="form-group col-md-12">
                <button class="btn btn-primary" @click.prevent="addVariation()">
                    <i class="fa fa-plus-circle"></i> Nova variação
                </button>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        name: '',
                        variations: [
                            {name: ''},
                        ]
                    }
                }
            },
        },

        data() {
            return {
                errors_grids: {name: ''},
                errors_variations: {
                    errors: {
                        name: ''
                    }
                },
            }
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        methods: {
            onSubmit() {
                const action = this.isUpdate ? 'updateGrid' : 'storeGrid'
                const msg = this.isUpdate ? 'Grade editada com sucesso' : 'Grade e variações cadastrado com sucesso'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.$router.push({name: 'grids'})
                    })
                    .catch((error) => {
                        if (error.response.data.hasOwnProperty('key') && error.response.data.location == 'variations') {
                            this.errors_variations = error.response.data
                        }
                        else {
                            this.errors_grids = error.response.data.errors
                        }
                    })
            },

            addVariation() {
                this.formData.variations.push({
                    name: ''
                })
            },

            removeVariation(index) {
                this.formData.variations.splice(index, 1)
            },

            backPage() {
                this.$router.push({name: 'grids'})
            }
        }
    }
</script>